# okapi

*okapi* is a container which provides the gateway-service for folio-components. This Image extends the generic [folioorg/okapi] image and adds the ability to configure the service by providing environment variables.

## supported tags

* 2.25.0-1, 2.25.0, 2.25, 2, latest ([Dockerfile])

## Usage of the image

The image can be used as follows

```bash
#$ docker run --name okapi \
  -p 9130:9130 \
  ubleipzig/okapi
```

## advanced startup

You can provide additional options via commandline as the okapi start-command is expecting it like this:
```bash
#$ docker run --rm -ti ubleipzig/okapi:latest cluster -Dpostgres_host=postgres-host
```
_this overrides the default value `localhost`, see [#Advanced-configuration]_

The first argument has always to be the start command of the okapi-service. All following arguments can be Java-arguments or okapi-service arguments. You can even mix them.

If you want to start a different command than the okapi-service, just specify it like so:
```bash
#$ docker run --rm -ti ubleipzig/okapi:latest /bin/bash
```
_this starts a regular bash-terminal as root user_

### deploy modules

Okapi makes only sense if there are modules that are connected to it. After deploying these modules they have to be made known to okap. To do that you can use the script

```bash
#$ docker run --rm -ti ubleipzig/okapi
```


## Advanced configuration

The following environment variables are used to configure the service. The specified values are the default values these variables have.

* `POSTGRES_HOST='localhost' `: sets the host of the PostgreSQL database server
* `POSTGRES_PORT='5432' `: sets the port of the the PostgreSQL database server
* `POSTGRES_USER='okapi' `: sets the username for the okapi-database
* `POSTGRES_PASSWORD='changeme' `: sets the password for the okapi-database user
* `POSTGRES_DB='okapi' `: sets the database name of the okapi-database
* `OKAPI_HOST='localhost' `: sets the host of the okapi-service
* `OKAPI_PORT='9130' `: sets the port of the okapi-service
* `OKAPI_URL='http://localhost:9130' `: sets the url where the okapi-service is available
* `OKAPI_CLUSTERHOST='localhost' `: sets the cluster-host of the okapi-service
* `OKAPI_NODENAME='okapi' `: sets the nodename of the okapi-service
* `OKAPI_LOGLEVEL='INFO' `: sets the error level to report
* `HAZELCAST_HOST='localhost' `: sets the hazelcast host
* `HAZELCAST_PORT='5701' `: sets the hazelcast port
* `CLUSTER_HOST='localhost' `: sets the cluster host
* `CLUSTER_PORT='5703' `: sets the cluster port
* `HAZELCAST_CONFIG_FILE='/etc/hazelcast.xml' `: sets the location of the hazelcast config-file

[folioorg/okapi]: https://hub.docker.com/r/folioorg/okapi/tags/