# okapi

This repository holds the files used to build the [okapi-image][Docker-Hub].

## Image-Tags

The images are created via a gitlab-pipeline, see [.gitlab-ci.yml]. There are several tags which can be used:

* `2.22.0-1`: points to a specific build. Each build is specified by a number. The higher, the latter.
* `2.22.0`: points to the latest build from the `2.22.0`-line. It is the same as the last `2.22.0-*`.
* `2.22`: points to the latest build from the `2.22`-line. If there will be a `2.22.1`-line it will point to that latest build.
* `2`: points to the latest build from the `2`-line. If there will be a `2.23`-line it will point to that latest build.
* `latest`: always points to the latest build.

## create Images

Pushing the Code to the Repository does nothing. Images are created via GIT-Tags.

```
git tag -a 2.22.0-1 -m 'minor optimization'
git push origin 2.22.0-1
```
_this will create a new image with a tag named `2.22.0-1`. Also the Tags `2.22.0`, `2.22`, `2` and `latest` will point to this image._

Only Repository-maintainers will be able to create a new Tag.

### Alpha-Images
Each branch results in an alpha-image named `services.ub.uni-leipzig.de:10443/bdd_dev/okapi:alpha-<branch-name>`. This images are built when the branch is pushed.

### Staging-Images
When a push to `master` is made gitlab-ci creates an image named `services.ub.uni-leipzig.de:10443/bdd_dev/okapi:staging`.

### Production-Images
If a Tag named `release/*` is pushed gitlab-ci creates an image named `ubleipzig/folio-okapi:<version>`.

## Contribution

In case you want to contribute please fork and make a pull-request at [Gitlab-hosting of Leipzig University]. This is due to internal policies and the higher flexibility when it comes to build images and push to [Docker-Hub]

## Todo

* Tests

[okapi-image]: https://git.sc.uni-leipzig.de/ubl/bdd_dev/docker/okapi
[.gitlab-ci.yml]: https://git.sc.uni-leipzig.de/ubl/bdd_dev/docker/okapi/blob/master/.gitlab-ci.yml
[Gitlab-hosting of Leipzig University]: https://git.sc.uni-leipzig.de/ubl/bdd_dev/docker/okapi
[Docker-Hub]: https://hub.docker.com/r/ubleipzig/okapi/